

pub fn part_one(input: &str) -> Option<u32> {
    let mut buffer: Vec<u8> = Vec::new();
    let mut result: Option<u32> = None;
    for (count,byte) in input.bytes().enumerate() {
        buffer.push(byte);
        if count >=4 {
         buffer.remove(0);
         let mut uniques = buffer.clone();
         uniques.sort();
         uniques.dedup();
         if uniques.len() == buffer.len() {
            result = Some((count+1).try_into().unwrap());
            break;
         }
        }
    }
    result
}

pub fn part_two(input: &str) -> Option<u32> {
    let mut buffer: Vec<u8> = Vec::new();
    let mut result: Option<u32> = None;
    for (count,byte) in input.bytes().enumerate() {
        buffer.push(byte);
        if count >=14 {
         buffer.remove(0);
         let mut uniques = buffer.clone();
         uniques.sort();
         uniques.dedup();
         if uniques.len() == buffer.len() {
            result = Some((count+1).try_into().unwrap());
            break;
         }
        }
    }
    result
}

fn main() {
    let input = &advent_of_code::read_file("inputs", 6);
    advent_of_code::solve!(1, part_one, input);
    advent_of_code::solve!(2, part_two, input);
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_part_one() {
        let input = advent_of_code::read_file("examples", 6);
        assert_eq!(part_one(&input), Some(7));
    }

    #[test]
    fn test_part_two() {
        let input = advent_of_code::read_file("examples", 6);
        assert_eq!(part_two(&input), Some(19));
    }
}
